10 REM  1997/9
20 REM        DRAW ELEMENT, DEFORMATION AND NODAL FORCE 
30 REM           ------- F2DR2.BAS FOR WINDOWS95 -------
40 REM                   BY TAKAYUKI HIRAI
50 DEFSTR Z
60 DIM MV(9,4000),X(20000),DU(20000),UUN(4000,4)
70 DIM SSG(4000),EN(300),PR(300),TH(300),IP(300),EE(3,3,300)
80 DIM MOU(400,3),CO(400,2),CW(400,2),CX(400,2),SR(400,11)
90 DIM XY(18),RN22(8),H22(2,8),GJ(2,2),GJI(2,2)
100 DIM GH(2,8),BMA(3,16),BML(3,4),DE(3),DF(18),QQ(2,400,2,2)
110 REM
120 REM    ------------ INPUT DATA ------------
130 OPEN "R1" FOR INPUT AS #1
132 open "SD" for append as #2
134 print #2,999
136 close #2
138 KILL"SD"
140 OPEN "SD" FOR OUTPUT AS #2
150 WP=3.14159:WI=1!/WP
160 CLS 
170 PRINT " "
180 PRINT "    DRAW STRESS ON POINTS "
190 PRINT " ":PRINT " "
200 INPUT "       SCALE OF STRESS =";SCS
210 PRINT " ":PRINT " "
220 PRINT #2," "
230 FOR I=1 TO 7:INPUT #1,ZZ:NEXT I
240 PRINT #2,ZZ:PRINT #2," "
245 ZM=RIGHT$(ZZ,5)
250 INPUT #1,ZZ:INPUT #1,ZZ:INPUT #1,ZZ
260 Z1=LEFT$(ZZ,15):NELE=VAL(RIGHT$(Z1,5))
270 Z1=LEFT$(ZZ,44):NODE=VAL(RIGHT$(Z1,5))
280 Z2=LEFT$(ZZ,66):NODT=VAL(RIGHT$(Z2,5))
290 Z3=LEFT$(ZZ,84):NMAT=VAL(RIGHT$(Z3,3))
300 Z3=LEFT$(ZZ,105):NGA=VAL(RIGHT$(Z3,3))
305 PRINT "  ELEMENTS, VERTEX NODES, TOTAL NODES, MATERIALS, GAUSS POINTS = ";NELE,NODE,NODT,NMAT,NGA
310 INPUT #1,ZZ
320 NONC=VAL(RIGHT$(ZZ,5))
325 PRINT "  CON.=1 NON.=0  = ";NONC
330 FOR I=1 TO 3:INPUT #1,ZZ:NEXT I
340 FOR I=1 TO NMAT
350 INPUT #1,N,EN(I),PR(I),TH(I),IP(I)
355 PRINT N,EN(I),PR(I),TH(I),IP(I)
360 IF IP(I)=1 THEN EN(I)=EN(I)/(1-PR(I)*PR(I))
370 IF IP(I)=1 THEN PR(I)=PR(I)/(1-PR(I))
380 IF ABS(PR(I)*PR(I)-1!)<.0001 THEN IRR=11000+I
390 IF IRR<>0 THEN PRINT #2," IRR = ";IRR
400 FOR J=1 TO 2
410 EE(3,J,I)=0!:EE(J,3,I)=0!
420 EE(J,J,I)=EN(I)/(1-PR(I)*PR(I))
430 EE(1,2,I)=EN(I)*PR(I)/(1-PR(I)*PR(I))
440 EE(2,1,I)=EE(1,2,I)
450 EE(3,3,I)=EN(I)/(1+PR(I))/2:NEXT J
460 NEXT I
470 FOR I=1 TO 2:INPUT #1,ZZ:NEXT I
480 FOR I=1 TO NELE
490 INPUT #1,N,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,X1,X2
495 PRINT N,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,X1,X2
500 MV(1,I)=A1:MV(2,I)=A2:MV(3,I)=A3:MV(4,I)=A4:MV(5,I)=A5
510 MV(6,I)=A6:MV(7,I)=A7:MV(8,I)=A8:MV(9,I)=A9:SSG(I)=A10
520 NEXT I
530 INPUT #1,ZZ:INPUT #1,ZZ
540 FOR I=1 TO NODT
550 INPUT #1,A1,A2,A3,A4,A5,A6,A7,A8,A9
555 PRINT A1,A2,A3,A4,A5,A6,A7,A8,A9
560 X(I*2-1)=A2:X(I*2)=A3
570 DU(I*2-1)=A8:DU(I*2)=A9
580 NEXT I
590 IF NONC<>0 THEN GOTO 650
600 INPUT #1,ZZ:INPUT #1,ZZ:INPUT #1,ZZ
610 FOR I=1 TO NELE
620 INPUT #1,N,UUN(I,1),UUN(I,2),UUN(I,3),UUN(I,4)
622 PRINT N,UUN(I,1),UUN(I,2),UUN(I,3),UUN(I,4)
624 NEXT I
630 REM
640 REM   --------- INPUT COORDINATE OF POINT ---------
650 PRINT " ":PRINT " "
660 PRINT "  CHOOSE THE WAY OF INPUTTING POINT COORDINATE,"
670 PRINT "       FILE D1                      WAY = 1"
680 PRINT "       KEY BOARD                    WAY = 2"
690 PRINT " ":INPUT "             WAY =";WAY
700 PRINT " ":PRINT " "
710 IF WAY=2 THEN GOTO 810
720 PRINT "         END DATA OF FILE D1 MUST BE 99999 "
730 CLOSE #1
740 OPEN "D1" FOR INPUT AS #1
750 FOR I9=1 TO 200:INPUT #1,MOU(I9,1)
760 IF MOU(I9,1)>89999! THEN GOTO 790
770 INPUT #1,MOU(I9,2),CO(I9,1),CO(I9,2)
780 NEXT I9
790 PRINT " ":I9=I9-1
800 IF WAY=1 THEN GOTO 1120
810 I9=0
820 CLS 
830 PRINT "   INPUT STRESS CALCULATION POINT COORDINATE FROM KEY BOARD; 
840 PRINT "              MOU1 = ELEMENT NUMBER"
850 PRINT "              MOU2 = 8010; ON A LINE PARALLEL TO XI-AXIS"
860 PRINT "                   = 8100; ON A LINE PARALLEL TO ETA-AXIS"
870 PRINT "                   = 8000; ON A POINT"
880 PRINT "                   = ELEMENT NUMBER; ON MESH IN MOU1-MOU2 ELEMENT":
890 PRINT "       END ;  MOU1 > 90000"
900 PRINT " "
910 INPUT "              MOU1 =";A1
920 IF A1>89999! THEN GOTO 1120
930 IF A1<1 THEN GOTO 820
940 IF A1>NELE THEN GOTO 820
950 PRINT " "
960 I9=I9+1:MOU(I9,1)=A1
970 INPUT "              MOU2 =";A2
980 MOU(I9,2)=A2
990 IF A2<=4000 THEN GOTO 820
1000 IF A2=8000 THEN GOTO 1080
1010 IF A2<>8100 THEN GOTO 1040
1020 PRINT " "
1030 INPUT "   INPUT XI-COORDINATE OF LINE =";CO(I9,1)
1040 IF A2<>8010 THEN GOTO 820
1050 PRINT " "
1060 INPUT "   INPUT ETA-COORDINATE OF LINE =";CO(I9,2)
1070 IF A2<>8000 THEN GOTO 820
1080 PRINT "   INPUT COORDINATE OF POINT"
1090 PRINT " ":INPUT "    XI-COORDINATE =";CO(I9,1)
1100 PRINT " ":INPUT "    ETA-COORDINATE =";CO(I9,2)
1110 GOTO 820
1120 I4=I9:I9=0
1130 FOR I=1 TO I4
1140 A1=MOU(I,1):A2=MOU(I,2):B1=CO(I,1):B2=CO(I,2)
1150 IF A2<=4000 THEN GOTO 1200
1160 IF A2=8010 THEN GOTO 1260
1170 IF A2=8100 THEN GOTO 1300
1180 I9=I9+1:MOU(I9,3)=A1:CW(I9,1)=B1:CW(I9,2)=B2
1190 GOTO 1330
1200 FOR J=A1 TO A2
1210 FOR K1=1 TO 3
1220 FOR K2=1 TO 3
1230 I9=I9+1:MOU(I9,3)=J:CW(I9,1)=-2+K1:CW(I9,2)=-2+K2
1240 NEXT K2:NEXT K1:NEXT J
1250 GOTO 1330
1260 FOR K1=1 TO 5
1270 I9=I9+1:MOU(I9,3)=A1:CW(I9,1)=(K1-3)/2:CW(I9,2)=B2
1280 NEXT K1
1290 GOTO 1330
1300 FOR K1=1 TO 5
1310 I9=I9+1:MOU(I9,3)=A1:CW(I9,1)=B1:CW(I9,2)=(K1-3)/2
1320 NEXT K1
1330 NEXT I
1340 REM
1350 REM   ------- CALCULATE STRESS AND DISPLACEMENT -------
1360 PRINT #2,"      H1 = MAXIMUM PRINCIPAL STRESS"
1370 PRINT #2,"      H2 = MINIMUM PRINCIPAL STRESS"
1380 PRINT #2,"      H3 = MAXIMUM SHEARING STRESS"
1390 PRINT #2,"   ANGLE = DIRECTION OF THE PRINCIPAL STRESS H1"
1400 PRINT #2," "
1410 PRINT #2," ELEMENT  COORDINATE X-Y   DISPLACEMENT X-Y    PRINCIPAL STRESS H1-H2-H3   ANGLE   NORMAL STRESSX-Y   SHEARING STRESS XY"
1420 FOR I4=1 TO I9
1430 M=MOU(I4,3):GZ=CW(I4,1):EA=CW(I4,2):MM=MV(9,M)
1440 FOR I=1 TO 8
1450 I3=MV(I,M):DF(2*I-1)=DU(I3*2-1):DF(2*I)=DU(2*I3)
1460 FOR JJ=1 TO 2
1470 XY(JJ+I*2-2)=X(I3*2-2+JJ):NEXT JJ:NEXT I
1480 FOR J=5 TO 7:SR(I4,J)=0:NEXT J
1490 IDE=0
1500 REM
1510 REM   ---------  GGG  ---------
1520 GZP=1!+GZ:EAP=1!+EA:GZM=1!-GZ:EAM=1!-EA
1530 GZ2=1!-GZ*GZ:EA2=1!-EA*EA
1540 RN22(1)=GZM*EAM*(-GZ-EA-1!)/4!
1550 RN22(2)=GZP*EAM*( GZ-EA-1!)/4!
1560 RN22(3)=GZP*EAP*( GZ+EA-1!)/4!
1570 RN22(4)=GZM*EAP*(-GZ+EA-1!)/4!
1580 RN22(5)=GZ2*EAM/2!
1590 RN22(6)=GZP*EA2/2!
1600 RN22(7)=GZ2*EAP/2!
1610 RN22(8)=GZM*EA2/2!
1620 H22(1,1)=EAM*(2!*GZ+EA)/4!
1630 H22(1,2)=EAM*(2!*GZ-EA)/4!
1640 H22(1,3)=EAP*(2!*GZ+EA)/4!
1650 H22(1,4)=EAP*(2!*GZ-EA)/4!
1660 H22(1,5)=-EAM*GZ
1670 H22(1,6)=EA2/2!
1680 H22(1,7)=-EAP*GZ
1690 H22(1,8)=-EA2/2!
1700 H22(2,1)=GZM*(2!*EA+GZ)/4!
1710 H22(2,2)=GZP*(2!*EA-GZ)/4!
1720 H22(2,3)=GZP*(2!*EA+GZ)/4!
1730 H22(2,4)=GZM*(2!*EA-GZ)/4!
1740 H22(2,5)=-GZ2/2!
1750 H22(2,6)=-GZP*EA
1760 H22(2,7)=GZ2/2!
1770 H22(2,8)=-GZM*EA
1780 REM
1790 REM   ---------  FFF  ---------
1800 FOR I=1 TO 2:FOR J=1 TO 2
1810 GJ(I,J)=0!
1820 FOR K=1 TO 8
1830 GJ(I,J)=GJ(I,J)+H22(I,K)*XY(K*2-2+J)
1840 NEXT K:NEXT J:NEXT I
1850 DET=GJ(1,1)*GJ(2,2)-GJ(1,2)*GJ(2,1)
1860 IF ABS(DET)>1E-09 THEN GOTO 1880
1870 IRR=40000!+M:IDE=IRR:GOTO 2500
1880 GJI(1,1)=GJ(2,2)/DET:GJI(2,1)=-GJ(2,1)/DET
1890 GJI(1,2)=-GJ(1,2)/DET:GJI(2,2)=GJ(1,1)/DET
1900 FOR I=1 TO 8:FOR J=1 TO 2
1910 GH(J,I)=0!
1920 FOR K=1 TO 2
1930 GH(J,I)=GH(J,I)+GJI(J,K)*H22(K,I):NEXT K:NEXT J:NEXT I
1940 FOR I=1 TO 3:FOR J=1 TO 16
1950 BMA(I,J)=0!:NEXT J:NEXT I
1960 FOR J=1 TO 8:
1970 BMA(1,2*J-1)=GH(1,J):BMA(2,2*J)=GH(2,J)
1980 BMA(3,2*J-1)=GH(2,J):BMA(3,2*J)=GH(1,J):NEXT J
1990 IF NONC<>0 THEN GOTO 2090
2000 FOR I=1 TO 2
2010 GH(I,1)=GJI(I,1)*(1!-3!*GZ*GZ)
2020 GH(I,2)=GJI(I,2)*(1!-3!*EA*EA):NEXT I
2030 FOR I=1 TO 3:FOR J=1 TO 4
2040 BML(I,J)=0!:NEXT J:NEXT I
2050 FOR J=1 TO 2
2060 BML(1,J)=GH(1,J):BML(2,J+2)=GH(2,J)
2070 BML(3,J)=GH(2,J):BML(3,J+2)=GH(1,J):NEXT J
2080 REM
2090 REM    ---------  TTT  ---------
2100 FOR I=1 TO 3
2110 DE(I)=0!
2120 FOR J=1 TO 16
2130 DE(I)=DE(I)+BMA(I,J)*DF(J):NEXT J:NEXT I
2140 IF NONC<>0 THEN GOTO 2170   
2150 FOR I=1 TO 3:FOR J=1 TO 4
2160 DE(I)=DE(I)+BML(I,J)*UUN(M,J):NEXT J:NEXT I
2170 FOR I=1 TO 3
2180 SR(I4,I+4)=0!
2190 FOR J=1 TO 3
2200 SR(I4,I+4)=SR(I4,I+4)+EE(I,J,MM)*DE(J):NEXT J:NEXT I
2210 S4=SSG(M)*EN(MM)/(1!-PR(MM))
2220 SR(I4,5)=SR(I4,5)-S4:SR(I4,6)=SR(I4,6)-S4
2230 A1=(SR(I4,5)-SR(I4,6))*.5:B1=-SR(I4,7)
2240 SR(I4,3)=SQR(A1*A1+B1*B1)
2250 SR(I4,1)=(SR(I4,5)+SR(I4,6))*.5+SR(I4,3)
2260 SR(I4,2)=(SR(I4,5)+SR(I4,6))*.5-SR(I4,3)
2270 IF A1=0 THEN GOTO 2330
2280 FUV=ATN(B1/A1)
2290 IF A1>0 THEN GOTO 2360
2300 FUV=FUV+3.14159
2310 IF B1<0 THEN FUV=FUV-6.28318
2320 GOTO 2360
2330 FUV=1.5708
2340 IF B1<0 THEN FUV=FUV-3.14159
2350 IF B1=0 THEN FUV=0!
2360 SR(I4,4)=-FUV/2
2370 A99=-FUV*90!/3.14159
2380 SR(I4,10)=0!
2390 SR(I4,11)=0!
2400 SR(I4,8)=0!
2410 SR(I4,9)=0!
2420 FOR I=1 TO 8
2430 SR(I4,8)=SR(I4,8)+RN22(I)*DF(2*I-1)
2440 SR(I4,9)=SR(I4,9)+RN22(I)*DF(2*I)
2450 SR(I4,10)=SR(I4,10)+RN22(I)*XY(I*2-1)
2460 SR(I4,11)=SR(I4,11)+RN22(I)*XY(2*I):NEXT I
2470 IF NONC<>0 THEN GOTO 2500
2480 SR(I4,8)=SR(I4,8)+(1!-GZ*GZ)*GZ*UUN(M,1)+(1!-EA*EA)*EA*UUN(M,2)
2490 SR(I4,9)=SR(I4,9)+(1!-GZ*GZ)*GZ*UUN(M,3)+(1!-EA*EA)*EA*UUN(M,4)
2500 IF IDE=0 THEN GOTO  2560
2510 PRINT #2," ---- ZERO DETERMINANT JACOBIAN ----"
2520 PRINT #2,M;SR(I4,10);SR(I4,11);SR(I4,8);SR(I4,9);" ---- ZERO DETERMINANT JACOBIAN ----"
2530 PRINT " ---- ZERO DETERMINANT JACOBIAN ----"
2540 PRINT M;SR(I4,10);SR(I4,11);SR(I4,8);SR(I4,9);" ---- ZERO DETERMINANT JACOBIAN ----"
2550 GOTO 2580
2560 PRINT #2,M;SR(I4,10),SR(I4,11),SR(I4,8),SR(I4,9),SR(I4,1),SR(I4,2),SR(I4,3),A99,SR(I4,5),SR(I4,6),SR(I4,7)
2570 PRINT M;SR(I4,10),SR(I4,11),SR(I4,8),SR(I4,9),SR(I4,1),SR(I4,2),SR(I4,3),A99,SR(I4,5),SR(I4,6),SR(I4,7)
2580 NEXT I4
2590 REM
2600 REM   ------------- SCALING ------------
2610 XA=999999!:XB=-999999!:YA=999999!:YB=-999999!
2620 FOR I=1 TO I9
2630 SF=SIN(SR(I,4))*SCS:CF=COS(SR(I,4))*SCS
2640 QQ(1,I,1,1)=SR(I,10)-SR(I,1)*CF
2650 QQ(1,I,1,2)=SR(I,11)-SR(I,1)*SF
2660 QQ(1,I,2,1)=SR(I,10)+SR(I,1)*CF
2670 QQ(1,I,2,2)=SR(I,11)+SR(I,1)*SF
2680 SF=SIN(SR(I,4)+WP/2)*SCS:CF=COS(SR(I,4)+WP/2)*SCS
2690 QQ(2,I,1,1)=SR(I,10)-SR(I,2)*CF
2700 QQ(2,I,1,2)=SR(I,11)-SR(I,2)*SF
2710 QQ(2,I,2,1)=SR(I,10)+SR(I,2)*CF
2720 QQ(2,I,2,2)=SR(I,11)+SR(I,2)*SF
2730 NEXT I
2740 FOR I=1 TO I9:FOR J=1 TO 2:FOR K=1 TO 2
2750 IF QQ(J,I,K,1)<XA THEN XA=QQ(J,I,K,1)
2760 IF QQ(J,I,K,1)>XB THEN XB=QQ(J,I,K,1)
2770 IF QQ(J,I,K,2)<YA THEN YA=QQ(J,I,K,2)
2780 IF QQ(J,I,K,2)>YB THEN YB=QQ(J,I,K,2)
2790 NEXT K:NEXT J:NEXT I
2800 XM=XB-XA:YM=YB-YA
2810 TRA=160/YM
2820 IF XM*4>YM*6 THEN TRA=250/XM
2830 REM
2840 REM   ------- DRAW PRE DEFORMED FIGURE -------
2842 #include"WINDOWS.BI"
2844 var FORM as object
2846 var BITMAP1 as object
2848 SETMAPMODE 1
2850 SETREDRAWMODE 1
2852 FORM.ATTACH GETHWND
2854 BITMAPOBJECT BITMAP1
2856 view (0,0)-(636,433)
2858 window (0,-3)-(620,210)
2860 color 0,15
2862 CLS
2864 SSSS=8/TRA/SCS
2866 PRINT"    RED TENSION, GREEN COMPRESSION, SCALE=";SSSS;"  MODEL=";ZM
2870 FOR I=1 TO NELE
2880 FOR K=1 TO I9
2890 IF I=MOU(K,3) THEN GOTO 2920
2900 NEXT K
2910 GOTO 3320
2920 X1=(X(2*MV(1,I)-1)-XA)*TRA*2+10 
2930 X2=(X(2*MV(5,I)-1)-XA)*TRA*2+10 
2940 X3=(X(2*MV(2,I)-1)-XA)*TRA*2+10 
2950 Y1=190-(X(2*MV(1,I))-YA)*TRA
2960 Y2=190-(X(2*MV(5,I))-YA)*TRA
2970 Y3=190-(X(2*MV(2,I))-YA)*TRA
2980 FOR J=1 TO 101:K=-1+(J-1)/50
2990 XX=CINT(K*(K-1)*X1/2+(1-K)*(K+1)*X2+K*(K+1)*X3/2)
3000 YY=CINT(K*(K-1)*Y1/2+(1-K)*(K+1)*Y2+K*(K+1)*Y3/2)
3010 pset(XX,YY),0:next J
3020 X1=(X(2*MV(2,I)-1)-XA)*TRA*2+10 
3030 X2=(X(2*MV(6,I)-1)-XA)*TRA*2+10 
3040 X3=(X(2*MV(3,I)-1)-XA)*TRA*2+10 
3050 Y1=190-(X(2*MV(2,I))-YA)*TRA
3060 Y2=190-(X(2*MV(6,I))-YA)*TRA
3070 Y3=190-(X(2*MV(3,I))-YA)*TRA
3080 FOR J=1 TO 101:K=-1+(J-1)/50
3090 XX=CINT(K*(K-1)*X1/2+(1-K)*(K+1)*X2+K*(K+1)*X3/2)
3100 YY=CINT(K*(K-1)*Y1/2+(1-K)*(K+1)*Y2+K*(K+1)*Y3/2)
3110 pset(XX,YY),0:next J
3120 X1=(X(2*MV(3,I)-1)-XA)*TRA*2+10 
3130 X2=(X(2*MV(7,I)-1)-XA)*TRA*2+10 
3140 X3=(X(2*MV(4,I)-1)-XA)*TRA*2+10 
3150 Y1=190-(X(2*MV(3,I))-YA)*TRA
3160 Y2=190-(X(2*MV(7,I))-YA)*TRA
3170 Y3=190-(X(2*MV(4,I))-YA)*TRA
3180 FOR J=1 TO 101:K=-1+(J-1)/50
3190 XX=CINT(K*(K-1)*X1/2+(1-K)*(K+1)*X2+K*(K+1)*X3/2)
3200 YY=CINT(K*(K-1)*Y1/2+(1-K)*(K+1)*Y2+K*(K+1)*Y3/2)
3210 pset(XX,YY),0:next J
3220 X1=(X(2*MV(4,I)-1)-XA)*TRA*2+10 
3230 X2=(X(2*MV(8,I)-1)-XA)*TRA*2+10 
3240 X3=(X(2*MV(1,I)-1)-XA)*TRA*2+10 
3250 Y1=190-(X(2*MV(4,I))-YA)*TRA
3260 Y2=190-(X(2*MV(8,I))-YA)*TRA
3270 Y3=190-(X(2*MV(1,I))-YA)*TRA
3280 FOR J=1 TO 101:K=-1+(J-1)/50
3290 XX=CINT(K*(K-1)*X1/2+(1-K)*(K+1)*X2+K*(K+1)*X3/2)
3300 YY=CINT(K*(K-1)*Y1/2+(1-K)*(K+1)*Y2+K*(K+1)*Y3/2)
3310 pset(XX,YY),0:next J
3320 NEXT I
3330 REM
3340 REM   --------- DRAW STRESS ---------
3350 FOR I=1 TO I9:FOR J=1 TO 2
3360 XL=CINT((QQ(J,I,1,1)-XA)*TRA*2+10)
3370 XR=CINT((QQ(J,I,2,1)-XA)*TRA*2+10)
3380 YL=CINT(190-(QQ(J,I,1,2)-YA)*TRA)
3390 YR=CINT(190-(QQ(J,I,2,2)-YA)*TRA)
3400 K4=5
3410 IF SR(I,J)<0 THEN K4=8
3420 LINE(XL,YL)-(XR,YR),PSET,K4
3430 IF J=2 THEN GOTO 3660
3440 S1=SIN(SR(I,4)+WP/4)*3:C1=COS(SR(I,4)+WP/4)*6
3450 S2=SIN(SR(I,4)-WP/4)*3:C2=COS(SR(I,4)-WP/4)*6
3460 IF SR(I,1)<0 THEN GOTO 3590
3470 IF XL>XR THEN GOTO 3500
3480 XL1=XL+C1:XL2=XL+C2
3490 XR1=XR-C1:XR2=XR-C2:GOTO 3520
3500 XL1=XL-C1:XL2=XL-C2
3510 XR1=XR+C1:XR2=XR+C2
3520 YL1=YL-S1:YL2=YL-S2
3530 YR1=YR+S1:YR2=YR+S2:GOTO 3560
3540 YL1=YL+S1:YL2=YL+S2
3550 YR1=YR-S1:YR2=YR-S2
3560 line(XL,YL)-(XL1,YL1),pset,3:line(XL,YL)-(XL2,YL2),pset,3
3570 LINE(XR,YR)-(XR1,YR1),PSET,3:LINE(XR,YR)-(XR2,YR2),PSET,3
3580 GOTO 3860
3590 XL1=(XL+XR)/2-C1:XL2=(XL+XR)/2-C2
3600 YL1=(YL+YR)/2+S1:YL2=(YL+YR)/2+S2
3610 XR1=(XL+XR)/2+C1:XR2=(XL+XR)/2+C2
3620 YR1=(YL+YR)/2-S1:YR2=(YL+YR)/2-S2
3630 line(XL1,YL1)-(XR1,YR1),pset,3
3640 LINE(XL2,YL2)-(XR2,YR2),PSET,3
3650 GOTO 3860
3660 S1=SIN(SR(I,4)+3*WP/4)*3:C1=COS(SR(I,4)+3*WP/4)*6
3670 S2=SIN(SR(I,4)+WP/4)*3:C2=COS(SR(I,4)+WP/4)*6
3680 IF SR(I,2)<0 THEN GOTO 3800
3690 XL1=XL+C1:XL2=XL+C2
3700 XR1=XR-C1:XR2=XR-C2:GOTO 3730
3710 XL1=XL-C1:XL2=XL-C2
3720 XR1=XR+C1:XR2=XR+C2
3730 YL1=YL-S1:YL2=YL-S2
3740 YR1=YR+S1:YR2=YR+S2:GOTO 3770
3750 YL1=YL+S1:YL2=YL+S2
3760 YR1=YR-S1:YR2=YR-S2
3770 line(XL,YL)-(XL1,YL1),pset,3:line(XL,YL)-(XL2,YL2),pset,3
3780 line(XR,YR)-(XR1,YR1),pset,3:line(XR,YR)-(XR2,YR2),pset,3
3790 GOTO 3860
3800 XL1=(XL+XR)/2-C1:XL2=(XL+XR)/2-C2
3810 YL1=(YL+YR)/2+S1:YL2=(YL+YR)/2+S2
3820 XR1=(XL+XR)/2+C1:XR2=(XL+XR)/2+C2
3830 YR1=(YL+YR)/2-S1:YR2=(YL+YR)/2-S2
3840 line(XL1,YL1)-(XR1,YR1),pset,3
3850 LINE(XL2,YL2)-(XR2,YR2),PSET,3
3860 NEXT J:NEXT I
3870 line(5,6)-(21,6),pset,5:line(5,6)-(5,-2),pset,8
3880 BITMAP1.CREATEBITMAP 636,433
3890 BITMAP1.BITBLT 0,0,636,433,FORM,0,-3
3900 BITMAP1.SAVEFILE"AAA.BMP"
3910 BITMAP1.DELETEOBJECT
3920 cls
3930 BITMAP1.LOADFILE"AAA.BMP"
3940 FORM.BITBLT 0,-3,636,433,BITMAP1,0,0
3950 FOR I8=1 TO 9000
3960 WAIT 10
3970 Z4=INKEY$
3980 IF Z4="Q" THEN GOTO 4030
3990 IF Z4="q" THEN GOTO 4030
4000 IF Z4="S" THEN GOTO 4030
4010 IF Z4="s" THEN GOTO 4030
4020 NEXT I8
4030 end
 